Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QMutex

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QMutex

All Implemented Interfaces:
  QtJambiInterface

    public class QMutex

extends QtJambiObject

The `QMutex` class provides access serialization between threads. The purpose of a `QMutex` is to protect an object, data structure or section of code so that only one thread can access it at a time (this is similar to the Java `synchronized` keyword). It is usually best to use a mutex with a QMutexLocker since this makes it easy to ensure that locking and unlocking are performed consistently.

For example, say there is a method that prints a message to the user on two lines:

            int number = 6;

            public void method1()
            {
                number *= 5;
                number /= 4;
            }

            public void method2()
            {
                number *= 3;
                number /= 2;
            }

If these two methods are called in succession, the following happens:

            // method1()
            number *= 5;        // number is now 30
            number /= 4;        // number is now 7

            // method2()
            number *= 3;        // number is now 21
            number /= 2;        // number is now 10

If these two methods are called simultaneously from two threads then the following sequence could result:

            // Thread 1 calls method1()
            number *= 5;        // number is now 30

            // Thread 2 calls method2().
            //
            // Most likely Thread 1 has been put to sleep by the operating
            // system to allow Thread 2 to run.
            number *= 3;        // number is now 90
            number /= 2;        // number is now 45

            // Thread 1 finishes executing.
            number /= 4;        // number is now 11, instead of 10

If we add a mutex, we should get the result we want:

            QMutex mutex = new QMutex();
            int number = 6;

            public void method1()
            {
                mutex.lock();
                number *= 5;
                number /= 4;
                mutex.unlock();
            }

            public void method2()
            {
                mutex.lock();
                number *= 3;
                number /= 2;
                mutex.unlock();
            }

Then only one thread can modify `number` at any given time and the result is correct. This is a trivial example, of course, but applies to any other case where things need to happen in a particular sequence.

When you call `lock()` in a thread, other threads that try to call `lock()` in the same place will block until the thread that got the lock calls `unlock()`. A non-blocking alternative to `lock()` is `tryLock()`.

See also:
  QMutexLocker, `QReadWriteLock`, `QSemaphore`, and `QWaitCondition`.

Nested Class Summary
`static class` | `QMutex.RecursionMode`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QMutex()` Constructs a new mutex.
`QMutex(QMutex.RecursionMode mode)` Constructs a new mutex.

Method Summary
`void` | `lock()` Locks the mutex.
`boolean` | `tryLock()` Attempts to lock the mutex.
`boolean` | `tryLock(int timeout)` Attempts to lock the mutex.
`void` | `unlock()` Unlocks the mutex.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QMutex

    public QMutex()

  Constructs a new mutex. The mutex is created in an unlocked state.

  If `mode` is `QMutex::Recursive` , a thread can lock the same mutex multiple times and the mutex won't be unlocked until a corresponding number of `unlock()` calls have been made. The default is `QMutex::NonRecursive` .

See also:
  `lock()`, and `unlock()`.

### QMutex

    public QMutex(QMutex.RecursionMode mode)

  Constructs a new mutex. The mutex is created in an unlocked state.

  If `mode` is `QMutex::Recursive` , a thread can lock the same mutex multiple times and the mutex won't be unlocked until a corresponding number of `unlock()` calls have been made. The default is `QMutex::NonRecursive` .

See also:
  `lock()`, and `unlock()`.

Method Detail

### lock

    public final void lock()

  Locks the mutex. If another thread has locked the mutex then this call will block until that thread has unlocked it.

  Calling this function multiple times on the same mutex from the same thread is allowed if this mutex is a `recursive mutex` . If this mutex is a `non-recursive mutex` , this function will dead-lock when the mutex is locked recursively.

See also:
  `unlock()`.

### tryLock

    public final boolean tryLock()

  Attempts to lock the mutex. If the lock was obtained, this function returns true. If another thread has locked the mutex, this function returns false immediately.

  If the lock was obtained, the mutex must be unlocked with `unlock()` before another thread can successfully lock it.

  Calling this function multiple times on the same mutex from the same thread is allowed if this mutex is a `recursive mutex` . If this mutex is a `non-recursive mutex` , this function will always return false when attempting to lock the mutex recursively.

See also:
  `lock()`, and `unlock()`.

### tryLock

    public final boolean tryLock(int timeout)

  Attempts to lock the mutex. This function returns true if the lock was obtained; otherwise it returns false. If another thread has locked the mutex, this function will wait for at most `timeout` milliseconds for the mutex to become available.

  Note: Passing a negative number as the `timeout` is equivalent to calling `lock()`, i.e. this function will wait forever until mutex can be locked if `timeout` is negative.

  If the lock was obtained, the mutex must be unlocked with `unlock()` before another thread can successfully lock it.

  Calling this function multiple times on the same mutex from the same thread is allowed if this mutex is a `recursive mutex` . If this mutex is a `non-recursive mutex` , this function will always return false when attempting to lock the mutex recursively.

See also:
  `lock()`, and `unlock()`.

### unlock

    public final void unlock()

  Unlocks the mutex. Attempting to unlock a mutex in a different thread to the one that locked it results in an error. Unlocking a mutex that is not locked results in undefined behavior.

See also:
  `lock()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD